<div id="body" class="container-fluid">
  <h6>World Holidays</h6>
  <div class="row mb-1">
    <div class="col-24">
      <dx-check-box [value]="false" text="Include Past Holidays"
                    (onValueChanged)="valueChangedHandler($event)"></dx-check-box>
    </div>
  </div>
  <dx-data-grid #grid id="grid" [dataSource]="items" keyExpr="wrldHldyId" [wordWrapEnabled]="true"
                [rowAlternationEnabled]="true" [showBorders]="true" [columnAutoWidth]="true"
                (onSelectionChanged)="selectionChangedHandler($event)"
                (onEditingStart)="loadEditForm($event)"
                (onToolbarPreparing)="onToolbarPreparing($event)"
                (onContentReady)="grid.instance.searchByText(grid.searchPanel.text.trim())"
                (onRowInserting)="saveForm($event)" (onRowUpdating)="saveForm($event)">
    <dxo-sorting mode="multiple"></dxo-sorting>
    <dxo-selection mode="multiple" showCheckBoxesMode="always" selectAllMode="page"></dxo-selection>
    <dxo-scrolling mode="standard" showScrollbar="always" useNative="false"></dxo-scrolling>
    <dxo-editing mode="form" [useIcons]="true" [allowUpdating]="true" [allowAdding]="true">
      <dxo-form>
        <dxi-item dataField="ctryCd" [colSpan]="1"></dxi-item>
        <dxi-item dataField="wrldHldyDt" [colSpan]="1"></dxi-item>
        <dxi-item dataField="wrldHldyDes" caption="Holiday Name" [colSpan]="2"></dxi-item>
      </dxo-form>
    </dxo-editing>
    <dxo-header-filter [visible]="true"></dxo-header-filter>
    <dxo-filter-panel [visible]="true"></dxo-filter-panel>
    <dxo-paging [pageSize]="50"></dxo-paging>
    <dxo-pager [showPageSizeSelector]="true" [allowedPageSizes]="[25, 50, 100]"></dxo-pager>
    <dxo-search-panel [visible]="true" [highlightCaseSensitive]="true"></dxo-search-panel>
    <dxi-column type="buttons" [buttons]="['edit']" headerCellTemplate="editHeaderTemplate" [minWidth]="50"></dxi-column>
    <dxi-column dataField="ctryCd" caption="Country" [allowHeaderFiltering]="true" [minWidth]="150">
      <dxi-validation-rule type="required"></dxi-validation-rule>
      <dxo-lookup [dataSource]="countryList" valueExpr="ctryCd" displayExpr="ctryNme">
      </dxo-lookup>
    </dxi-column>
    <!--<dxi-column dataField="ctyNme" caption="City" [allowHeaderFiltering]="false" [minWidth]="150"></dxi-column>-->
    <dxi-column dataField="wrldHldyDt" caption="Date" dataType="date"
                [allowHeaderFiltering]="true" [minWidth]="150">
      <dxi-validation-rule type="required"></dxi-validation-rule>
    </dxi-column>
    <dxi-column dataField="wrldHldyDes" caption="Holiday" dataType="string"
                [allowHeaderFiltering]="false" [minWidth]="150">
      <dxi-validation-rule type="required"></dxi-validation-rule>
      <dxi-validation-rule type="stringLength" [max]="75"
                           message="Holiday Name max characters is 75."></dxi-validation-rule>
    </dxi-column>
    <dxi-column dataField="createdByAdId" caption="Created By" dataType="string"
                [allowHeaderFiltering]="false" [minWidth]="100"></dxi-column>
    <dxi-column dataField="modifiedByAdId" caption="Modified By" dataType="string"
                [allowHeaderFiltering]="false" [minWidth]="100"></dxi-column>
    <dxi-column dataField="modfdDt" cellTemplate="localStartTime" caption="Modified Date"
                dataType="string" [allowHeaderFiltering]="false" [minWidth]="150"></dxi-column>
    <div *dxTemplate="let cell of 'localStartTime'">
      <span>{{cell.text | date:'MM/dd/yyyy hh:mm a'}}</span>
    </div>
    <div *dxTemplate="let data of 'editHeaderTemplate'">
      <div>Edit</div>
    </div>
    <div *dxTemplate="let data of 'removeTemplate'">
      <button class="btn btn-sm btn-primary" type="button"
              [disabled]="!selectedItemKeys.length" (click)="deleteRows()">
        Remove Selected Records
      </button>
    </div>
  </dx-data-grid>
</div>
